#!/user/local/bin/ruby -Ks
=begin
Tv: asahi press SENTENCE pNX`
⑫: t@C̍\͖̐Q
: v1.00 2003-02-22 by nomad
        쐬
      v1.01 2003-03-05 by nomad
        Asahi::decode() 
      v1.02 2004-01-11 by nomad
        Asahi::decode()  ruby 1.8 ŃG[ɂȂ̂C
: I[v\[X

NX\:
  module Asahi
  class ListFile < File
    include Asahi
    include Enumerable
  class DataFile < File
    include Asahi
    include Enumerable
  class InfFile < File

gp:
  # pꌩoꗗo͂
  require 'AsahiLib.rb'

  homeDir = ARGV.shift.gsub(/\\/, '/')
  ListFile::open(homeDir + EntFiles['elist']) { |f|
    f.init
    f.each { |v|
      puts v
    }
  }

=end

####

  EntFiles = { 'elist' => '/LST/E_MID.LST',
               'jlist' => '/LST/J_MID.LST',
               'data'  => '/HON/MID_HON.DAT',
               'inf'   => '/HON/MID_HON.INF' }
  ExaFiles = { 'elist' => '/LST/E_REI.LST',
               'jlist' => '/LST/J_REI.LST',
               'data'  => '/HON/REI_HON.DAT',
               'inf'   => '/HON/REI_HON.INF' }

  EntFiles2 = { 'elist' => '/LST/E_MID2.LST',
                'jlist' => '/LST/J_MID2.LST',
                'data'  => '/HON/MID_HON2.DAT',
                'inf'   => '/HON/MID_HON2.INF' }
  ExaFiles2 = { 'elist' => '/LST/E_REI2.LST',
                'jlist' => '/LST/J_REI2.LST',
                'data'  => '/HON/REI_HON2.DAT',
                'inf'   => '/HON/REI_HON2.INF' }

#### 
module Asahi

  #### 
  def decode(str)

    q, r = str.length.divmod(4)

    a = str.unpack('N' + q.to_s)  # 擪 4 oCgPʂŏ
    b = str[ -r, r].unpack('C*')  # c 1 oCgPʂŏ
    a.collect! { |x| ( ~x + 0x51132222 ) & 0x00FFFFFFFF }  #== v1.02 for ruby1.8
    b.collect! { |x| ~x }

    a.pack('N*') + b.pack('C*')
  end

  module_function :decode

end

#### .LST
class ListFile < File
  include Asahi
  include Enumerable

  HEADER_SIZE = 32

  attr_reader :recCount

=begin
  #  new ͎s邪Aopen ɂ͎sȂ?
  def initialize(path, mode = 'r')
    super
    binmode
    header = read(HEADER_SIZE)
    if header != nil
      x, x, x, @recCount, @recSize, @strSize, xSize, = header.unpack('L*')
    else
      @recCount = @recSize = @strSize = 0
    end
  end
=end

  def init
    binmode
    header = read(HEADER_SIZE)
    if header != nil
      x, x, x, @recCount, @recSize, @strSize, xSize, = header.unpack('L*')
    else
      @recCount = @recSize = @strSize = 0
    end
  end

  def dic(n)
    seek(n * @recSize + HEADER_SIZE)
#    str = read(@strSize)
#    title = decode(str[0, 4])
    title = decode(read(4))
    return title[0, 2]
  end

  def getRec(n)
    seek(n * @recSize + HEADER_SIZE)
    return decode(read(@strSize)).sub(/\x00+$/, '')
  end

  def each
    @recCount.times { |i|
      yield getRec(i)
    }
  end

end

#### .DAT
class DataFile < File
  include Asahi
  include Enumerable

  HEADER_SIZE = 4

  attr_reader :recCount

  def init
    binmode
    header = read(HEADER_SIZE)
    if header != nil
      @recCount, = header.unpack('L*')
    else
      @recCount = 0
    end
  end

  def getRec(n)
    self.seek(n * 8 + HEADER_SIZE)
    pos, len = read(8).unpack('L2')
    seek(pos)
    decode(read(len))
  end

  def each
    @recCount.times { |i|
      yield getRec(i)
    }
  end

end

#### .INF
class InfFile < File

  HEADER_SIZE = 8

  attr_reader :recCount

  def init
    binmode
    header = read(HEADER_SIZE)
    if header != nil
      @recCount, = header.unpack('L*')
    else
      @recCount = 0
    end
  end

  def jumpList(n)
    seek(n * 8 + HEADER_SIZE)
    pos, len = read(8).unpack('L2')
    seek(pos + 16)
    pos, len = read(8).unpack('L2')
    a = Array::new
    if len != 0
      seek(pos)
      data = read(len)
      (len / 20).times { |i|
        pos, len, dummy, num, = data[i * 20, 20].unpack('L5')
        a[i] = [pos, len, num]
      }
    end
    return a
  end

end

__END__

t@C̍\

.LST

bytes
  wb_ (32 oCg)
    8  <unknown>
    4  ԍe[uJnʒu(?)
    4  R[h <n>
    4  R[hTCY <m>
    4  ꗗ\TCY <a>
    4  tf[^(?)TCY <b>

  <m> * <n> R[h
     <a>  ꗗ\ (ÍA͕ null l)
     <b>  tf[^(? lŒ̂悤)
     16(?)  <unknown>

    4 * <n> ԍe[u(?)

.DAT

bytes
    4  R[h <n>

    8 * <n> e[u
     4  f[^ʒu
     4  f[^TCY

  f[^ (ÍAsR[h͕ 0x0D)

.INF

bytes
    4  R[h <n>
    4  e[uڐ(?) <m>

    8 * <n> e[u
     4  f[^ʒu
     4  f[^TCY

  f[^ (ef[^͎̍\)
     8 * <m>(?) e[u
      4  ʒu
      4  TCY
         (2 ԖڂtHgpA3 ԖڂQƐpA
          TCY 0 Ȃ炻̃f[^͂Ȃ)

  QƐ (1 ̎QƐɂ 20 oCg)
      4  QƕJnʒu (0..) ({擪)
      4  Qƕ
      4  <unknown> (Œ̂悤)
      4  QƐԍ (1..)
      4  <unknown> (Œ̂悤ȁAQƐt@CID?)

